	lea	rsi,[compressed_ELF64]
segment_delta_instruction_dword	=	$ + 3
	lea	rdi,[rip+1235h]
segment_delta_start:
	push	rdi		; entry must start at the begin of code segment
	call	decompress_segment

; reconstruct code
	push	rdi
	pop	rbp

	pop	rdi
	push	rdi

	pop	rbx
	push	rbx

post_uncompress_restore_L0:
	mov	eax,dword [rdi]
	scasb			; trick how to do RDI+1 in 1 byte instruction (Note! This assume DF=0)
				; setting DF=0 has been done in call decompress_segment at CLD instruction
	mov	ecx,eax
	lea	edx,[rax+(100h-0E8h)]	; transforms E8->0 E9->1 in 3 bytes instruction
;	and	ecx,07FFF0h		; lea gpr64,[rip+...] transform 4x8Dx5, 4x8DxD->408D05
; above commented was previous filter, now we use this one:
	and	ch,0C7h
	and	ah,11110000b		; transforms 0F8x->0F80
	cmp	dl,1			; check call (0) , jmp (1)
	jnbe	post_uncompress_restore_L5
	mov	eax,dword [rdi]
	cmp	ax,-2*1			; for code section smaller than 10000h
					; between procedure and instruction following call instruction
	jc	post_uncompress_next_byte
	jmp	post_uncompress_restore1
post_uncompress_restore_L5:
	cmp	ax,800Fh		; check jcc (conditional jump) opcode 0F8x
	jz	post_uncompress_restore2
;	cmp	ecx,058D40h
;	jnz	post_uncompress_next_byte
; above commented was previous filter, now we use this one:
	cmp	cx,058Dh		; lea gpr,[rip+...]
	jz	post_uncompress_restore2
	and	cl,0FCh			; transform 88,89,8A,8B->88
	cmp	cx,0588h		; mov gpr,[rip+...]  mov [rip+...],gpr
	jnz	post_uncompress_next_byte
;post_uncompress_restore3:
;	scasb
; above commented was previous filter, now we don't need it
post_uncompress_restore2:
	scasb
post_uncompress_restore1:
	mov	eax,dword [rdi]
; restore original dword
	bswap	eax
	lea	eax,[rbx+rax*1+code_segment_limit]
	sub	eax,edi
	stosd
post_uncompress_next_byte:
	cmp	rdi,rbp
	jc	post_uncompress_restore_L0

segment_delta_data_dword	=	$ + 3
	lea	rdi,[rip+2678h]
segment_delta_data_start:

;	call	decompress_segment
;	ret
; this is smaller:
;	jmp	decompress_segment
; we needn't to jump if the procedure follows immediatelly

decompress_segment:
include	'uncompress_routine.inc'
	ret
